// COM_PICDlg.cpp : implementation file
//

#include "stdafx.h"
#include "COM_PIC.h"
#include "COM_PICDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCOM_PICDlg dialog

CCOM_PICDlg::CCOM_PICDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCOM_PICDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCOM_PICDlg)
	m_baud = 9600;
	m_com = 1;
	m_read = 0;
	m_write = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCOM_PICDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCOM_PICDlg)
	DDX_Text(pDX, IDC_BAUD, m_baud);
	DDX_Text(pDX, IDC_COM, m_com);
	DDX_Text(pDX, IDC_READ, m_read);
	DDX_Text(pDX, IDC_WRITE, m_write);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCOM_PICDlg, CDialog)
	//{{AFX_MSG_MAP(CCOM_PICDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnOpenPort)
	ON_BN_CLICKED(IDC_BUTTON2, OnWrite)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCOM_PICDlg message handlers

BOOL CCOM_PICDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCOM_PICDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCOM_PICDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCOM_PICDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCOM_PICDlg::OnOpenPort() 
{
	// TODO: Add your control notification handler code here

	UpdateData(true);	

	if(m_baud == 0 || m_com == 0 )
	{
		MessageBox("Bad params", "Error", MB_ICONERROR);
		return;;
	}

	bool b = sg.Open(m_com, m_baud);
	if(b == true)
	{
		MessageBox("Port open Ok!", "Info", MB_ICONINFORMATION);

		SetTimer(1, 500, NULL); // set timer for 0.5 sec
	}
	else
	{
		MessageBox("Port open ERROR", "Info", MB_ICONERROR);
	}
	
}

void CCOM_PICDlg::OnWrite() 
{
	// TODO: Add your control notification handler code here

	UpdateData(true);	

	char data = m_write;

	sg.Send(&data, 1); // 1 byte to send
	
}

void CCOM_PICDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default

	char buf;
	int readCount = sg.Recv(&buf, 1); // 1 byte for read

	if(readCount > 0)
	{
		m_read = (unsigned char)buf;
		UpdateData(false);
	}
	
	CDialog::OnTimer(nIDEvent);
}
